<a id="mypy-boto3-dataexchange"></a>

# mypy-boto3-dataexchange

[![PyPI - mypy-boto3-dataexchange](https://img.shields.io/pypi/v/mypy-boto3-dataexchange.svg?color=blue)](https://pypi.org/project/mypy-boto3-dataexchange)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-dataexchange.svg?color=blue)](https://pypi.org/project/mypy-boto3-dataexchange)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-dataexchange?color=blue)](https://pypistats.org/packages/mypy-boto3-dataexchange)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.DataExchange 1.18.58](https://boto3.amazonaws.com/v1/documentation/api/1.18.58/reference/services/dataexchange.html#DataExchange)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 5.5.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-dataexchange docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_dataexchange/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-dataexchange](#mypy-boto3-dataexchange)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `DataExchange` service.

```bash
python -m pip install boto3-stubs[dataexchange]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[dataexchange]` in your environment:
  `python -m pip install 'boto3-stubs[dataexchange]'`

Both type checking and auto-complete should work for `DataExchange` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[dataexchange]` in your environment:
  `python -m pip install 'boto3-stubs[dataexchange]'`

Both type checking and auto-complete should work for `DataExchange` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[dataexchange]` in your environment:
  `python -m pip install 'boto3-stubs[dataexchange]'`
- Run `mypy` as usual

Type checking should work for `DataExchange` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[dataexchange]` in your environment:
  `python -m pip install 'boto3-stubs[dataexchange]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `DataExchange` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`DataExchangeClient` provides annotations for `boto3.client("dataexchange")`.

```python
import boto3

from mypy_boto3_dataexchange import DataExchangeClient

client: DataExchangeClient = boto3.client("dataexchange")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: DataExchangeClient = session.client("dataexchange")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_dataexchange.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_dataexchange import DataExchangeClient
from mypy_boto3_dataexchange.paginator import (
    ListDataSetRevisionsPaginator,
    ListDataSetsPaginator,
    ListEventActionsPaginator,
    ListJobsPaginator,
    ListRevisionAssetsPaginator,
)

client: DataExchangeClient = boto3.client("dataexchange")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_data_set_revisions_paginator: ListDataSetRevisionsPaginator = client.get_paginator("list_data_set_revisions")
list_data_sets_paginator: ListDataSetsPaginator = client.get_paginator("list_data_sets")
list_event_actions_paginator: ListEventActionsPaginator = client.get_paginator("list_event_actions")
list_jobs_paginator: ListJobsPaginator = client.get_paginator("list_jobs")
list_revision_assets_paginator: ListRevisionAssetsPaginator = client.get_paginator("list_revision_assets")
```

<a id="literals"></a>

### Literals

`mypy_boto3_dataexchange.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_dataexchange.literals import (
    AssetTypeType,
    CodeType,
    JobErrorLimitNameType,
    JobErrorResourceTypesType,
    ListDataSetRevisionsPaginatorName,
    ListDataSetsPaginatorName,
    ListEventActionsPaginatorName,
    ListJobsPaginatorName,
    ListRevisionAssetsPaginatorName,
    OriginType,
    ServerSideEncryptionTypesType,
    StateType,
    TypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: AssetTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_dataexchange.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_dataexchange.type_defs import (
    ActionTypeDef,
    AssetDestinationEntryTypeDef,
    AssetDetailsTypeDef,
    AssetEntryTypeDef,
    AssetSourceEntryTypeDef,
    AutoExportRevisionDestinationEntryTypeDef,
    AutoExportRevisionToS3RequestDetailsTypeDef,
    CancelJobRequestRequestTypeDef,
    CreateDataSetRequestRequestTypeDef,
    CreateDataSetResponseTypeDef,
    CreateEventActionRequestRequestTypeDef,
    CreateEventActionResponseTypeDef,
    CreateJobRequestRequestTypeDef,
    CreateJobResponseTypeDef,
    CreateRevisionRequestRequestTypeDef,
    CreateRevisionResponseTypeDef,
    DataSetEntryTypeDef,
    DeleteAssetRequestRequestTypeDef,
    DeleteDataSetRequestRequestTypeDef,
    DeleteEventActionRequestRequestTypeDef,
    DeleteRevisionRequestRequestTypeDef,
    DetailsTypeDef,
    EventActionEntryTypeDef,
    EventTypeDef,
    ExportAssetToSignedUrlRequestDetailsTypeDef,
    ExportAssetToSignedUrlResponseDetailsTypeDef,
    ExportAssetsToS3RequestDetailsTypeDef,
    ExportAssetsToS3ResponseDetailsTypeDef,
    ExportRevisionsToS3RequestDetailsTypeDef,
    ExportRevisionsToS3ResponseDetailsTypeDef,
    ExportServerSideEncryptionTypeDef,
    GetAssetRequestRequestTypeDef,
    GetAssetResponseTypeDef,
    GetDataSetRequestRequestTypeDef,
    GetDataSetResponseTypeDef,
    GetEventActionRequestRequestTypeDef,
    GetEventActionResponseTypeDef,
    GetJobRequestRequestTypeDef,
    GetJobResponseTypeDef,
    GetRevisionRequestRequestTypeDef,
    GetRevisionResponseTypeDef,
    ImportAssetFromSignedUrlJobErrorDetailsTypeDef,
    ImportAssetFromSignedUrlRequestDetailsTypeDef,
    ImportAssetFromSignedUrlResponseDetailsTypeDef,
    ImportAssetsFromS3RequestDetailsTypeDef,
    ImportAssetsFromS3ResponseDetailsTypeDef,
    JobEntryTypeDef,
    JobErrorTypeDef,
    ListDataSetRevisionsRequestRequestTypeDef,
    ListDataSetRevisionsResponseTypeDef,
    ListDataSetsRequestRequestTypeDef,
    ListDataSetsResponseTypeDef,
    ListEventActionsRequestRequestTypeDef,
    ListEventActionsResponseTypeDef,
    ListJobsRequestRequestTypeDef,
    ListJobsResponseTypeDef,
    ListRevisionAssetsRequestRequestTypeDef,
    ListRevisionAssetsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    OriginDetailsTypeDef,
    PaginatorConfigTypeDef,
    RequestDetailsTypeDef,
    ResponseDetailsTypeDef,
    ResponseMetadataTypeDef,
    RevisionDestinationEntryTypeDef,
    RevisionEntryTypeDef,
    RevisionPublishedTypeDef,
    S3SnapshotAssetTypeDef,
    StartJobRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAssetRequestRequestTypeDef,
    UpdateAssetResponseTypeDef,
    UpdateDataSetRequestRequestTypeDef,
    UpdateDataSetResponseTypeDef,
    UpdateEventActionRequestRequestTypeDef,
    UpdateEventActionResponseTypeDef,
    UpdateRevisionRequestRequestTypeDef,
    UpdateRevisionResponseTypeDef,
)

def get_structure() -> ActionTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-dataexchange` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-dataexchange docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_dataexchange/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
